<?php

// *******************************************************
// SambaPOS4 Product Import Tool
// Version 2.0 (8/06/2014)
// *******************************************************
// Created by John Sheather
// *******************************************************
// Developed and Tested using WAMPServer 2.5 32bit
// http://www.wampserver.com/en/#download-wrapper
//
// Component Versions used
// Apache 2.4.9
// PHP 5.5.12
// MYSQL 5.6.17
// *******************************************************


// *******************************************************
// User Settings
// *******************************************************
//
// SQL Express Server Details - Set to your details from your connection string
// example: data source = localhost\SAMBAPOS; user id=sa; password=sambapos; database=import
$myServer = "localhost\SAMBAPOS";
$myUser = "sa";
$myPass = "sambapos";
$myDB = "import"; 

// Timezone - http://php.net/manual/en/timezones.php
date_default_timezone_set('Australia/Sydney');

// Menu Defaults
// Colours can be by Name or by RGB Code (#AAFF00) - http://colorschemedesigner.com/
$DefaultCategoryButtonColour = "Orange";
$DefaultMenuItemButtonColour = "Green";

$CategoryButtonHeight = "30";
$SubCategoryButtonHeight = "45";
$MenuItemButonHeight = "45";

$DefaultColumnCount = "2";
$DefaultNumberPad = "1"; // 2-Large, 1-Small, 0-None

$MenuButtonLength = 32; // Creates automatic Product Name wrapping on Menu Button 

// *******************************************************
// End of user settings
// *******************************************************


// Starting Variables
$MenuGroupCode = '';
$InvTransDoc = '0';

// Todays Date/Time
$today = date("Y-m-d H:i:s"); 
$start_time = date("H:i:s"); 
echo "Start : ".$start_time."<br>";

//connection to MSSQL database
$dbhandle = odbc_connect("Driver={SQL Server Native Client 10.0};Server=$myServer;Database=$myDB;", $myUser, $myPass)
  or die("Couldn't connect to SQL Server on $myServer"); 
echo 'Connected successfully - MSSQL<br><br>';

//Check if WorkPeriod exists
$query = "SELECT Id FROM WorkPeriods";
$result = odbc_exec($dbhandle, $query);
$rows = odbc_num_rows($result);
if ($rows == 0)
{
echo "<BR><B>Start A WorkPeriod First.</B>";
die;
}



// Start Reading import.csv file
ini_set("auto_detect_line_endings", 1);
$current_row = 1;
$handle = fopen("import.csv", "r");
while ( ($csv_data = fgetcsv($handle, 10000, ",") ) !== FALSE )
{
    $number_of_fields = count($csv_data);
    if ($current_row == 1)
    {
    //Header line
    }
    else
{

$CreateMenu = $csv_data[0];
$CreateInventory = $csv_data[1];
$GroupCode = $csv_data[2];
$SubGroupCode = $csv_data[3];
$Barcode = $csv_data[4];
$ProductName = $csv_data[5];
$MenuName = $csv_data[6];
$InventoryName = $csv_data[7];
$PortionName = $csv_data[8];
$Multiplier = $csv_data[9];
$Price = $csv_data[10];
$BaseUnit = $csv_data[11];
$TransUnit = $csv_data[12];
$TransMulti = $csv_data[13];
$RecipeQty = $csv_data[14];
$InvQty = $csv_data[15];
$CostPrice = $csv_data[16];
$WarehouseName = $csv_data[17];
$CategoryButtonColour = $csv_data[18];
$MenuItemButtonColour = $csv_data[19];

$CreateMenu = strtoupper($CreateMenu);
$CreateInventory = strtoupper($CreateInventory);


// Shorten long MenuNames by adding carriage returns.

If (strlen($MenuName) > $MenuButtonLength)
{
$pos = strrpos($MenuName," ",$MenuButtonLength - strlen($MenuName));
if ($pos > 0) { $MenuName = substr_replace($MenuName,"\\r",$pos,1); }
}

If (strlen($MenuName) > ($MenuButtonLength * 2))
{
$pos = strrpos($MenuName," ",($MenuButtonLength * 2) - strlen($MenuName));
if ($pos > 0) { $MenuName = substr_replace($MenuName,"\\r",$pos,1); }
}



if ($MenuName == "") { $MenuName = $ProductName; }
if ($InventoryName == "") { $InventoryName = $ProductName; }
if ($CategoryButtonColour == "") { $CategoryButtonColour = $DefaultCategoryButtonColour; }
if ($MenuItemButtonColour == "") { $MenuItemButtonColour = $DefaultMenuItemButtonColour; }

if ($GroupCode == "") { $GroupCode = "Default"; }
if ($PortionName == "") { $PortionName = "Normal"; }
if ($Multiplier == "") { $Multiplier = "1"; }

if ($CreateInventory == 'Y') {
	if ($BaseUnit == "") { $BaseUnit = "Ea"; }
	if ($TransUnit == "") { $TransUnit = "Ea"; }
	if ($TransMulti == "") { $TransMulti = "1"; }
	if ($RecipeQty == "") { $RecipeQty = "1"; }
}


// Check if Product Name already exists
// If product name exists, then product is skipped.
$query = "SELECT Name FROM MenuItems where Name='".$ProductName."'";
$result = odbc_exec($dbhandle, $query);
$rows = odbc_num_rows($result);


if (($ProductName != "") && ($rows == 0)) { 


// Create new Menu Category if needed
if ($CreateMenu != 'N')
{

//Check if a Menu exists
// Does not create - need to fix this *****************
$query = "SELECT Id FROM ScreenMenus where Name ='".$CreateMenu."'";
$result = odbc_exec($dbhandle, $query);
$rows = odbc_num_rows($result);
if ($rows == 0) { echo "<BR><B>Create A Menu First - '<i>$CreateMenu</i>' does not exist.</B>"; die; }
$row = odbc_fetch_array($result);
$menu_id = $row["Id"];

$query = "SELECT Id FROM ScreenMenuCategories where Name = '".$GroupCode."'";
$result = odbc_exec($dbhandle, $query);
$rows = odbc_num_rows($result);
if ($rows == 0) {

$query = "INSERT INTO ScreenMenuCategories (Name,SortOrder,ScreenMenuId,MostUsedItemsCategory,ColumnCount,MenuItemButtonHeight,MenuItemButtonColor,MenuItemFontSize,WrapText,PageCount,MainButtonHeight,MainButtonColor,MainFontSize,SubButtonHeight,SubButtonRows,NumeratorType,MaxItems) VALUES ('".$GroupCode."','0','".$menu_id."','0','".$DefaultColumnCount."','".$MenuItemButonHeight."','".$MenuItemButtonColour."','30','0','1','".$CategoryButtonHeight."','".$CategoryButtonColour."','30','".$SubCategoryButtonHeight."','1','".$DefaultNumberPad."','0')\n";
$result = odbc_exec($dbhandle, $query);

echo "<B>Menu Category - ".$GroupCode."</B><br>";

}

$query = "SELECT Id FROM ScreenMenuCategories where Name = '".$GroupCode."'";
$result = odbc_exec($dbhandle, $query);
$row = odbc_fetch_array($result);
$smc_id = $row["Id"];


}

// Start importing Products
$query = "INSERT INTO MenuItems (GroupCode,Barcode,Name) VALUES ('".$GroupCode."','".$Barcode."','".$ProductName."')\n";
echo $ProductName."<br>";
$result = odbc_exec($dbhandle, $query);

$query = "SELECT MAX(id) as maxid FROM MenuItems";
$result = odbc_exec($dbhandle, $query);

$row = odbc_fetch_array($result);
$mi_id = $row["maxid"];


// Setup Menu Products
if ($CreateMenu != 'N')
{
$query = "INSERT INTO ScreenMenuItems (Name,ScreenMenuCategoryId,MenuItemId,SortOrder,AutoSelect,ButtonColor,Quantity,FontSize,SubMenuTag) VALUES ('".$MenuName."','".$smc_id."','".$mi_id."','0','0','".$MenuItemButtonColour."','1','1','".$SubGroupCode."')\n";
$result = odbc_exec($dbhandle, $query);

$query = "SELECT MAX(id) as maxid FROM ScreenMenuItems";
$result = odbc_exec($dbhandle, $query);

$row = odbc_fetch_array($result);
$smi_id = $row["maxid"];
}



$query = "INSERT INTO MenuItemPortions (Name,MenuItemId,Multiplier) VALUES ('".$PortionName."','".$mi_id."','".$Multiplier."')\n";
$result = odbc_exec($dbhandle, $query);

$query = "SELECT MAX(id) as maxid FROM MenuItemPortions";
$result = odbc_exec($dbhandle, $query);

$row = odbc_fetch_array($result);
$mipo_id = $row["maxid"];



$query = "INSERT INTO MenuItemPrices (MenuItemPortionId,Price) VALUES ('".$mipo_id."','".$Price."')\n";
$result = odbc_exec($dbhandle, $query);

$query = "SELECT MAX(id) as maxid FROM MenuItemPrices";
$result = odbc_exec($dbhandle, $query);

$row = odbc_fetch_array($result);
$mip_id = $row["maxid"];


if ($CreateInventory == 'Y')
{
$query = "INSERT INTO InventoryItems (GroupCode,BaseUnit,TransactionUnit,TransactionUnitMultiplier,Name,Warehouse) VALUES ('".$GroupCode."','".$BaseUnit."','".$TransUnit."','".$TransMulti."','".$InventoryName."','".$WarehouseName."')\n";
$result = odbc_exec($dbhandle, $query);

$query = "SELECT MAX(id) as maxid FROM InventoryItems";
$result = odbc_exec($dbhandle, $query);

$row = odbc_fetch_array($result);
$ii_id = $row["maxid"];



$query = "INSERT INTO Recipes (FixedCost,Name,Portion_Id) VALUES ('0.00','".$ProductName."','".$mipo_id."')\n";
$result = odbc_exec($dbhandle, $query);

$query = "SELECT MAX(id) as maxid FROM Recipes";
$result = odbc_exec($dbhandle, $query);

$row = odbc_fetch_array($result);
$r_id = $row["maxid"];



$query = "INSERT INTO RecipeItems (RecipeId,Quantity,InventoryItem_Id) VALUES ('".$r_id."','".$RecipeQty."','".$ii_id."')\n";
$result = odbc_exec($dbhandle, $query);


// Add Inventory Document for Opening Stock
if ($InvQty != '0')
{
if ($InvTransDoc == '0')
{
$query = "INSERT INTO InventoryTransactionDocuments (Date,Name) VALUES ('".$today."','Opening Stock')\n";
$result = odbc_exec($dbhandle, $query);

$query = "SELECT MAX(id) as maxid FROM InventoryTransactionDocuments";
$result = odbc_exec($dbhandle, $query);
$row = odbc_fetch_array($result);
$itd_id = $row["maxid"];

$InvTransDoc = '1';
}

$query = "SELECT Id FROM Warehouses where Name = '".$WarehouseName."'";
$result = odbc_exec($dbhandle, $query);
$row = odbc_fetch_array($result);
$warehouse_id = $row["Id"];


$query = "INSERT INTO InventoryTransactions (InventoryTransactionDocumentId,InventoryTransactionTypeId,SourceWarehouseId,TargetWarehouseId,Date,Unit,Multiplier,Quantity,Price,InventoryItem_Id) VALUES ('".$itd_id."','1','0','".$warehouse_id."','".$today."','".$TransUnit."','".$TransMulti."','".$InvQty."','".$CostPrice."','".$ii_id."')\n";
$result = odbc_exec($dbhandle, $query);
}

    }

}
}
    $current_row++;

}

$finish_time = date("H:i:s"); 
echo "<br>Finish : ".$finish_time;
$time1 = strtotime($start_time);
$time2 = strtotime($finish_time);
$diff = $time2 - $time1;
echo "<br>Execution Time : ".date('i:s', $diff);

//close the DB connections
odbc_close($dbhandle);
?> 